/**
 * Autogenerated by Thrift Compiler (0.13.0)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package org.eclipse.hawk.service.api;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked", "unused"})
@javax.annotation.Generated(value = "Autogenerated by Thrift Compiler (0.13.0)", date = "2021-04-18")
public class ModelElement implements org.apache.thrift.TBase<ModelElement, ModelElement._Fields>, java.io.Serializable, Cloneable, Comparable<ModelElement> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("ModelElement");

  private static final org.apache.thrift.protocol.TField ID_FIELD_DESC = new org.apache.thrift.protocol.TField("id", org.apache.thrift.protocol.TType.STRING, (short)1);
  private static final org.apache.thrift.protocol.TField REPOSITORY_URL_FIELD_DESC = new org.apache.thrift.protocol.TField("repositoryURL", org.apache.thrift.protocol.TType.STRING, (short)2);
  private static final org.apache.thrift.protocol.TField FILE_FIELD_DESC = new org.apache.thrift.protocol.TField("file", org.apache.thrift.protocol.TType.STRING, (short)3);
  private static final org.apache.thrift.protocol.TField METAMODEL_URI_FIELD_DESC = new org.apache.thrift.protocol.TField("metamodelUri", org.apache.thrift.protocol.TType.STRING, (short)4);
  private static final org.apache.thrift.protocol.TField TYPE_NAME_FIELD_DESC = new org.apache.thrift.protocol.TField("typeName", org.apache.thrift.protocol.TType.STRING, (short)5);
  private static final org.apache.thrift.protocol.TField ATTRIBUTES_FIELD_DESC = new org.apache.thrift.protocol.TField("attributes", org.apache.thrift.protocol.TType.LIST, (short)6);
  private static final org.apache.thrift.protocol.TField REFERENCES_FIELD_DESC = new org.apache.thrift.protocol.TField("references", org.apache.thrift.protocol.TType.LIST, (short)7);
  private static final org.apache.thrift.protocol.TField CONTAINERS_FIELD_DESC = new org.apache.thrift.protocol.TField("containers", org.apache.thrift.protocol.TType.LIST, (short)8);

  private static final org.apache.thrift.scheme.SchemeFactory STANDARD_SCHEME_FACTORY = new ModelElementStandardSchemeFactory();
  private static final org.apache.thrift.scheme.SchemeFactory TUPLE_SCHEME_FACTORY = new ModelElementTupleSchemeFactory();

  public @org.apache.thrift.annotation.Nullable java.lang.String id; // optional
  public @org.apache.thrift.annotation.Nullable java.lang.String repositoryURL; // optional
  public @org.apache.thrift.annotation.Nullable java.lang.String file; // optional
  public @org.apache.thrift.annotation.Nullable java.lang.String metamodelUri; // optional
  public @org.apache.thrift.annotation.Nullable java.lang.String typeName; // optional
  public @org.apache.thrift.annotation.Nullable java.util.List<AttributeSlot> attributes; // optional
  public @org.apache.thrift.annotation.Nullable java.util.List<ReferenceSlot> references; // optional
  public @org.apache.thrift.annotation.Nullable java.util.List<ContainerSlot> containers; // optional

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    ID((short)1, "id"),
    REPOSITORY_URL((short)2, "repositoryURL"),
    FILE((short)3, "file"),
    METAMODEL_URI((short)4, "metamodelUri"),
    TYPE_NAME((short)5, "typeName"),
    ATTRIBUTES((short)6, "attributes"),
    REFERENCES((short)7, "references"),
    CONTAINERS((short)8, "containers");

    private static final java.util.Map<java.lang.String, _Fields> byName = new java.util.HashMap<java.lang.String, _Fields>();

    static {
      for (_Fields field : java.util.EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // ID
          return ID;
        case 2: // REPOSITORY_URL
          return REPOSITORY_URL;
        case 3: // FILE
          return FILE;
        case 4: // METAMODEL_URI
          return METAMODEL_URI;
        case 5: // TYPE_NAME
          return TYPE_NAME;
        case 6: // ATTRIBUTES
          return ATTRIBUTES;
        case 7: // REFERENCES
          return REFERENCES;
        case 8: // CONTAINERS
          return CONTAINERS;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new java.lang.IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    @org.apache.thrift.annotation.Nullable
    public static _Fields findByName(java.lang.String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final java.lang.String _fieldName;

    _Fields(short thriftId, java.lang.String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public java.lang.String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final _Fields optionals[] = {_Fields.ID,_Fields.REPOSITORY_URL,_Fields.FILE,_Fields.METAMODEL_URI,_Fields.TYPE_NAME,_Fields.ATTRIBUTES,_Fields.REFERENCES,_Fields.CONTAINERS};
  public static final java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    java.util.Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new java.util.EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.ID, new org.apache.thrift.meta_data.FieldMetaData("id", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.REPOSITORY_URL, new org.apache.thrift.meta_data.FieldMetaData("repositoryURL", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.FILE, new org.apache.thrift.meta_data.FieldMetaData("file", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.METAMODEL_URI, new org.apache.thrift.meta_data.FieldMetaData("metamodelUri", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.TYPE_NAME, new org.apache.thrift.meta_data.FieldMetaData("typeName", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRING)));
    tmpMap.put(_Fields.ATTRIBUTES, new org.apache.thrift.meta_data.FieldMetaData("attributes", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, AttributeSlot.class))));
    tmpMap.put(_Fields.REFERENCES, new org.apache.thrift.meta_data.FieldMetaData("references", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.StructMetaData(org.apache.thrift.protocol.TType.STRUCT, ReferenceSlot.class))));
    tmpMap.put(_Fields.CONTAINERS, new org.apache.thrift.meta_data.FieldMetaData("containers", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRUCT            , "ContainerSlot"))));
    metaDataMap = java.util.Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(ModelElement.class, metaDataMap);
  }

  public ModelElement() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public ModelElement(ModelElement other) {
    if (other.isSetId()) {
      this.id = other.id;
    }
    if (other.isSetRepositoryURL()) {
      this.repositoryURL = other.repositoryURL;
    }
    if (other.isSetFile()) {
      this.file = other.file;
    }
    if (other.isSetMetamodelUri()) {
      this.metamodelUri = other.metamodelUri;
    }
    if (other.isSetTypeName()) {
      this.typeName = other.typeName;
    }
    if (other.isSetAttributes()) {
      java.util.List<AttributeSlot> __this__attributes = new java.util.ArrayList<AttributeSlot>(other.attributes.size());
      for (AttributeSlot other_element : other.attributes) {
        __this__attributes.add(new AttributeSlot(other_element));
      }
      this.attributes = __this__attributes;
    }
    if (other.isSetReferences()) {
      java.util.List<ReferenceSlot> __this__references = new java.util.ArrayList<ReferenceSlot>(other.references.size());
      for (ReferenceSlot other_element : other.references) {
        __this__references.add(new ReferenceSlot(other_element));
      }
      this.references = __this__references;
    }
    if (other.isSetContainers()) {
      java.util.List<ContainerSlot> __this__containers = new java.util.ArrayList<ContainerSlot>(other.containers.size());
      for (ContainerSlot other_element : other.containers) {
        __this__containers.add(new ContainerSlot(other_element));
      }
      this.containers = __this__containers;
    }
  }

  public ModelElement deepCopy() {
    return new ModelElement(this);
  }

  @Override
  public void clear() {
    this.id = null;
    this.repositoryURL = null;
    this.file = null;
    this.metamodelUri = null;
    this.typeName = null;
    this.attributes = null;
    this.references = null;
    this.containers = null;
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getId() {
    return this.id;
  }

  public ModelElement setId(@org.apache.thrift.annotation.Nullable java.lang.String id) {
    this.id = id;
    return this;
  }

  public void unsetId() {
    this.id = null;
  }

  /** Returns true if field id is set (has been assigned a value) and false otherwise */
  public boolean isSetId() {
    return this.id != null;
  }

  public void setIdIsSet(boolean value) {
    if (!value) {
      this.id = null;
    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getRepositoryURL() {
    return this.repositoryURL;
  }

  public ModelElement setRepositoryURL(@org.apache.thrift.annotation.Nullable java.lang.String repositoryURL) {
    this.repositoryURL = repositoryURL;
    return this;
  }

  public void unsetRepositoryURL() {
    this.repositoryURL = null;
  }

  /** Returns true if field repositoryURL is set (has been assigned a value) and false otherwise */
  public boolean isSetRepositoryURL() {
    return this.repositoryURL != null;
  }

  public void setRepositoryURLIsSet(boolean value) {
    if (!value) {
      this.repositoryURL = null;
    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getFile() {
    return this.file;
  }

  public ModelElement setFile(@org.apache.thrift.annotation.Nullable java.lang.String file) {
    this.file = file;
    return this;
  }

  public void unsetFile() {
    this.file = null;
  }

  /** Returns true if field file is set (has been assigned a value) and false otherwise */
  public boolean isSetFile() {
    return this.file != null;
  }

  public void setFileIsSet(boolean value) {
    if (!value) {
      this.file = null;
    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getMetamodelUri() {
    return this.metamodelUri;
  }

  public ModelElement setMetamodelUri(@org.apache.thrift.annotation.Nullable java.lang.String metamodelUri) {
    this.metamodelUri = metamodelUri;
    return this;
  }

  public void unsetMetamodelUri() {
    this.metamodelUri = null;
  }

  /** Returns true if field metamodelUri is set (has been assigned a value) and false otherwise */
  public boolean isSetMetamodelUri() {
    return this.metamodelUri != null;
  }

  public void setMetamodelUriIsSet(boolean value) {
    if (!value) {
      this.metamodelUri = null;
    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.String getTypeName() {
    return this.typeName;
  }

  public ModelElement setTypeName(@org.apache.thrift.annotation.Nullable java.lang.String typeName) {
    this.typeName = typeName;
    return this;
  }

  public void unsetTypeName() {
    this.typeName = null;
  }

  /** Returns true if field typeName is set (has been assigned a value) and false otherwise */
  public boolean isSetTypeName() {
    return this.typeName != null;
  }

  public void setTypeNameIsSet(boolean value) {
    if (!value) {
      this.typeName = null;
    }
  }

  public int getAttributesSize() {
    return (this.attributes == null) ? 0 : this.attributes.size();
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.Iterator<AttributeSlot> getAttributesIterator() {
    return (this.attributes == null) ? null : this.attributes.iterator();
  }

  public void addToAttributes(AttributeSlot elem) {
    if (this.attributes == null) {
      this.attributes = new java.util.ArrayList<AttributeSlot>();
    }
    this.attributes.add(elem);
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.List<AttributeSlot> getAttributes() {
    return this.attributes;
  }

  public ModelElement setAttributes(@org.apache.thrift.annotation.Nullable java.util.List<AttributeSlot> attributes) {
    this.attributes = attributes;
    return this;
  }

  public void unsetAttributes() {
    this.attributes = null;
  }

  /** Returns true if field attributes is set (has been assigned a value) and false otherwise */
  public boolean isSetAttributes() {
    return this.attributes != null;
  }

  public void setAttributesIsSet(boolean value) {
    if (!value) {
      this.attributes = null;
    }
  }

  public int getReferencesSize() {
    return (this.references == null) ? 0 : this.references.size();
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.Iterator<ReferenceSlot> getReferencesIterator() {
    return (this.references == null) ? null : this.references.iterator();
  }

  public void addToReferences(ReferenceSlot elem) {
    if (this.references == null) {
      this.references = new java.util.ArrayList<ReferenceSlot>();
    }
    this.references.add(elem);
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.List<ReferenceSlot> getReferences() {
    return this.references;
  }

  public ModelElement setReferences(@org.apache.thrift.annotation.Nullable java.util.List<ReferenceSlot> references) {
    this.references = references;
    return this;
  }

  public void unsetReferences() {
    this.references = null;
  }

  /** Returns true if field references is set (has been assigned a value) and false otherwise */
  public boolean isSetReferences() {
    return this.references != null;
  }

  public void setReferencesIsSet(boolean value) {
    if (!value) {
      this.references = null;
    }
  }

  public int getContainersSize() {
    return (this.containers == null) ? 0 : this.containers.size();
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.Iterator<ContainerSlot> getContainersIterator() {
    return (this.containers == null) ? null : this.containers.iterator();
  }

  public void addToContainers(ContainerSlot elem) {
    if (this.containers == null) {
      this.containers = new java.util.ArrayList<ContainerSlot>();
    }
    this.containers.add(elem);
  }

  @org.apache.thrift.annotation.Nullable
  public java.util.List<ContainerSlot> getContainers() {
    return this.containers;
  }

  public ModelElement setContainers(@org.apache.thrift.annotation.Nullable java.util.List<ContainerSlot> containers) {
    this.containers = containers;
    return this;
  }

  public void unsetContainers() {
    this.containers = null;
  }

  /** Returns true if field containers is set (has been assigned a value) and false otherwise */
  public boolean isSetContainers() {
    return this.containers != null;
  }

  public void setContainersIsSet(boolean value) {
    if (!value) {
      this.containers = null;
    }
  }

  public void setFieldValue(_Fields field, @org.apache.thrift.annotation.Nullable java.lang.Object value) {
    switch (field) {
    case ID:
      if (value == null) {
        unsetId();
      } else {
        setId((java.lang.String)value);
      }
      break;

    case REPOSITORY_URL:
      if (value == null) {
        unsetRepositoryURL();
      } else {
        setRepositoryURL((java.lang.String)value);
      }
      break;

    case FILE:
      if (value == null) {
        unsetFile();
      } else {
        setFile((java.lang.String)value);
      }
      break;

    case METAMODEL_URI:
      if (value == null) {
        unsetMetamodelUri();
      } else {
        setMetamodelUri((java.lang.String)value);
      }
      break;

    case TYPE_NAME:
      if (value == null) {
        unsetTypeName();
      } else {
        setTypeName((java.lang.String)value);
      }
      break;

    case ATTRIBUTES:
      if (value == null) {
        unsetAttributes();
      } else {
        setAttributes((java.util.List<AttributeSlot>)value);
      }
      break;

    case REFERENCES:
      if (value == null) {
        unsetReferences();
      } else {
        setReferences((java.util.List<ReferenceSlot>)value);
      }
      break;

    case CONTAINERS:
      if (value == null) {
        unsetContainers();
      } else {
        setContainers((java.util.List<ContainerSlot>)value);
      }
      break;

    }
  }

  @org.apache.thrift.annotation.Nullable
  public java.lang.Object getFieldValue(_Fields field) {
    switch (field) {
    case ID:
      return getId();

    case REPOSITORY_URL:
      return getRepositoryURL();

    case FILE:
      return getFile();

    case METAMODEL_URI:
      return getMetamodelUri();

    case TYPE_NAME:
      return getTypeName();

    case ATTRIBUTES:
      return getAttributes();

    case REFERENCES:
      return getReferences();

    case CONTAINERS:
      return getContainers();

    }
    throw new java.lang.IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new java.lang.IllegalArgumentException();
    }

    switch (field) {
    case ID:
      return isSetId();
    case REPOSITORY_URL:
      return isSetRepositoryURL();
    case FILE:
      return isSetFile();
    case METAMODEL_URI:
      return isSetMetamodelUri();
    case TYPE_NAME:
      return isSetTypeName();
    case ATTRIBUTES:
      return isSetAttributes();
    case REFERENCES:
      return isSetReferences();
    case CONTAINERS:
      return isSetContainers();
    }
    throw new java.lang.IllegalStateException();
  }

  @Override
  public boolean equals(java.lang.Object that) {
    if (that == null)
      return false;
    if (that instanceof ModelElement)
      return this.equals((ModelElement)that);
    return false;
  }

  public boolean equals(ModelElement that) {
    if (that == null)
      return false;
    if (this == that)
      return true;

    boolean this_present_id = true && this.isSetId();
    boolean that_present_id = true && that.isSetId();
    if (this_present_id || that_present_id) {
      if (!(this_present_id && that_present_id))
        return false;
      if (!this.id.equals(that.id))
        return false;
    }

    boolean this_present_repositoryURL = true && this.isSetRepositoryURL();
    boolean that_present_repositoryURL = true && that.isSetRepositoryURL();
    if (this_present_repositoryURL || that_present_repositoryURL) {
      if (!(this_present_repositoryURL && that_present_repositoryURL))
        return false;
      if (!this.repositoryURL.equals(that.repositoryURL))
        return false;
    }

    boolean this_present_file = true && this.isSetFile();
    boolean that_present_file = true && that.isSetFile();
    if (this_present_file || that_present_file) {
      if (!(this_present_file && that_present_file))
        return false;
      if (!this.file.equals(that.file))
        return false;
    }

    boolean this_present_metamodelUri = true && this.isSetMetamodelUri();
    boolean that_present_metamodelUri = true && that.isSetMetamodelUri();
    if (this_present_metamodelUri || that_present_metamodelUri) {
      if (!(this_present_metamodelUri && that_present_metamodelUri))
        return false;
      if (!this.metamodelUri.equals(that.metamodelUri))
        return false;
    }

    boolean this_present_typeName = true && this.isSetTypeName();
    boolean that_present_typeName = true && that.isSetTypeName();
    if (this_present_typeName || that_present_typeName) {
      if (!(this_present_typeName && that_present_typeName))
        return false;
      if (!this.typeName.equals(that.typeName))
        return false;
    }

    boolean this_present_attributes = true && this.isSetAttributes();
    boolean that_present_attributes = true && that.isSetAttributes();
    if (this_present_attributes || that_present_attributes) {
      if (!(this_present_attributes && that_present_attributes))
        return false;
      if (!this.attributes.equals(that.attributes))
        return false;
    }

    boolean this_present_references = true && this.isSetReferences();
    boolean that_present_references = true && that.isSetReferences();
    if (this_present_references || that_present_references) {
      if (!(this_present_references && that_present_references))
        return false;
      if (!this.references.equals(that.references))
        return false;
    }

    boolean this_present_containers = true && this.isSetContainers();
    boolean that_present_containers = true && that.isSetContainers();
    if (this_present_containers || that_present_containers) {
      if (!(this_present_containers && that_present_containers))
        return false;
      if (!this.containers.equals(that.containers))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    int hashCode = 1;

    hashCode = hashCode * 8191 + ((isSetId()) ? 131071 : 524287);
    if (isSetId())
      hashCode = hashCode * 8191 + id.hashCode();

    hashCode = hashCode * 8191 + ((isSetRepositoryURL()) ? 131071 : 524287);
    if (isSetRepositoryURL())
      hashCode = hashCode * 8191 + repositoryURL.hashCode();

    hashCode = hashCode * 8191 + ((isSetFile()) ? 131071 : 524287);
    if (isSetFile())
      hashCode = hashCode * 8191 + file.hashCode();

    hashCode = hashCode * 8191 + ((isSetMetamodelUri()) ? 131071 : 524287);
    if (isSetMetamodelUri())
      hashCode = hashCode * 8191 + metamodelUri.hashCode();

    hashCode = hashCode * 8191 + ((isSetTypeName()) ? 131071 : 524287);
    if (isSetTypeName())
      hashCode = hashCode * 8191 + typeName.hashCode();

    hashCode = hashCode * 8191 + ((isSetAttributes()) ? 131071 : 524287);
    if (isSetAttributes())
      hashCode = hashCode * 8191 + attributes.hashCode();

    hashCode = hashCode * 8191 + ((isSetReferences()) ? 131071 : 524287);
    if (isSetReferences())
      hashCode = hashCode * 8191 + references.hashCode();

    hashCode = hashCode * 8191 + ((isSetContainers()) ? 131071 : 524287);
    if (isSetContainers())
      hashCode = hashCode * 8191 + containers.hashCode();

    return hashCode;
  }

  @Override
  public int compareTo(ModelElement other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = java.lang.Boolean.valueOf(isSetId()).compareTo(other.isSetId());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetId()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.id, other.id);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetRepositoryURL()).compareTo(other.isSetRepositoryURL());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetRepositoryURL()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.repositoryURL, other.repositoryURL);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetFile()).compareTo(other.isSetFile());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetFile()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.file, other.file);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetMetamodelUri()).compareTo(other.isSetMetamodelUri());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMetamodelUri()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.metamodelUri, other.metamodelUri);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetTypeName()).compareTo(other.isSetTypeName());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetTypeName()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.typeName, other.typeName);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetAttributes()).compareTo(other.isSetAttributes());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetAttributes()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.attributes, other.attributes);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetReferences()).compareTo(other.isSetReferences());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetReferences()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.references, other.references);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = java.lang.Boolean.valueOf(isSetContainers()).compareTo(other.isSetContainers());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetContainers()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.containers, other.containers);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  @org.apache.thrift.annotation.Nullable
  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    scheme(iprot).read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    scheme(oprot).write(oprot, this);
  }

  @Override
  public java.lang.String toString() {
    java.lang.StringBuilder sb = new java.lang.StringBuilder("ModelElement(");
    boolean first = true;

    if (isSetId()) {
      sb.append("id:");
      if (this.id == null) {
        sb.append("null");
      } else {
        sb.append(this.id);
      }
      first = false;
    }
    if (isSetRepositoryURL()) {
      if (!first) sb.append(", ");
      sb.append("repositoryURL:");
      if (this.repositoryURL == null) {
        sb.append("null");
      } else {
        sb.append(this.repositoryURL);
      }
      first = false;
    }
    if (isSetFile()) {
      if (!first) sb.append(", ");
      sb.append("file:");
      if (this.file == null) {
        sb.append("null");
      } else {
        sb.append(this.file);
      }
      first = false;
    }
    if (isSetMetamodelUri()) {
      if (!first) sb.append(", ");
      sb.append("metamodelUri:");
      if (this.metamodelUri == null) {
        sb.append("null");
      } else {
        sb.append(this.metamodelUri);
      }
      first = false;
    }
    if (isSetTypeName()) {
      if (!first) sb.append(", ");
      sb.append("typeName:");
      if (this.typeName == null) {
        sb.append("null");
      } else {
        sb.append(this.typeName);
      }
      first = false;
    }
    if (isSetAttributes()) {
      if (!first) sb.append(", ");
      sb.append("attributes:");
      if (this.attributes == null) {
        sb.append("null");
      } else {
        sb.append(this.attributes);
      }
      first = false;
    }
    if (isSetReferences()) {
      if (!first) sb.append(", ");
      sb.append("references:");
      if (this.references == null) {
        sb.append("null");
      } else {
        sb.append(this.references);
      }
      first = false;
    }
    if (isSetContainers()) {
      if (!first) sb.append(", ");
      sb.append("containers:");
      if (this.containers == null) {
        sb.append("null");
      } else {
        sb.append(this.containers);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, java.lang.ClassNotFoundException {
    try {
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class ModelElementStandardSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public ModelElementStandardScheme getScheme() {
      return new ModelElementStandardScheme();
    }
  }

  private static class ModelElementStandardScheme extends org.apache.thrift.scheme.StandardScheme<ModelElement> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, ModelElement struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // ID
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.id = iprot.readString();
              struct.setIdIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // REPOSITORY_URL
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.repositoryURL = iprot.readString();
              struct.setRepositoryURLIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 3: // FILE
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.file = iprot.readString();
              struct.setFileIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 4: // METAMODEL_URI
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.metamodelUri = iprot.readString();
              struct.setMetamodelUriIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 5: // TYPE_NAME
            if (schemeField.type == org.apache.thrift.protocol.TType.STRING) {
              struct.typeName = iprot.readString();
              struct.setTypeNameIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 6: // ATTRIBUTES
            if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
              {
                org.apache.thrift.protocol.TList _list176 = iprot.readListBegin();
                struct.attributes = new java.util.ArrayList<AttributeSlot>(_list176.size);
                @org.apache.thrift.annotation.Nullable AttributeSlot _elem177;
                for (int _i178 = 0; _i178 < _list176.size; ++_i178)
                {
                  _elem177 = new AttributeSlot();
                  _elem177.read(iprot);
                  struct.attributes.add(_elem177);
                }
                iprot.readListEnd();
              }
              struct.setAttributesIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 7: // REFERENCES
            if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
              {
                org.apache.thrift.protocol.TList _list179 = iprot.readListBegin();
                struct.references = new java.util.ArrayList<ReferenceSlot>(_list179.size);
                @org.apache.thrift.annotation.Nullable ReferenceSlot _elem180;
                for (int _i181 = 0; _i181 < _list179.size; ++_i181)
                {
                  _elem180 = new ReferenceSlot();
                  _elem180.read(iprot);
                  struct.references.add(_elem180);
                }
                iprot.readListEnd();
              }
              struct.setReferencesIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 8: // CONTAINERS
            if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
              {
                org.apache.thrift.protocol.TList _list182 = iprot.readListBegin();
                struct.containers = new java.util.ArrayList<ContainerSlot>(_list182.size);
                @org.apache.thrift.annotation.Nullable ContainerSlot _elem183;
                for (int _i184 = 0; _i184 < _list182.size; ++_i184)
                {
                  _elem183 = new ContainerSlot();
                  _elem183.read(iprot);
                  struct.containers.add(_elem183);
                }
                iprot.readListEnd();
              }
              struct.setContainersIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, ModelElement struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.id != null) {
        if (struct.isSetId()) {
          oprot.writeFieldBegin(ID_FIELD_DESC);
          oprot.writeString(struct.id);
          oprot.writeFieldEnd();
        }
      }
      if (struct.repositoryURL != null) {
        if (struct.isSetRepositoryURL()) {
          oprot.writeFieldBegin(REPOSITORY_URL_FIELD_DESC);
          oprot.writeString(struct.repositoryURL);
          oprot.writeFieldEnd();
        }
      }
      if (struct.file != null) {
        if (struct.isSetFile()) {
          oprot.writeFieldBegin(FILE_FIELD_DESC);
          oprot.writeString(struct.file);
          oprot.writeFieldEnd();
        }
      }
      if (struct.metamodelUri != null) {
        if (struct.isSetMetamodelUri()) {
          oprot.writeFieldBegin(METAMODEL_URI_FIELD_DESC);
          oprot.writeString(struct.metamodelUri);
          oprot.writeFieldEnd();
        }
      }
      if (struct.typeName != null) {
        if (struct.isSetTypeName()) {
          oprot.writeFieldBegin(TYPE_NAME_FIELD_DESC);
          oprot.writeString(struct.typeName);
          oprot.writeFieldEnd();
        }
      }
      if (struct.attributes != null) {
        if (struct.isSetAttributes()) {
          oprot.writeFieldBegin(ATTRIBUTES_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.attributes.size()));
            for (AttributeSlot _iter185 : struct.attributes)
            {
              _iter185.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
      }
      if (struct.references != null) {
        if (struct.isSetReferences()) {
          oprot.writeFieldBegin(REFERENCES_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.references.size()));
            for (ReferenceSlot _iter186 : struct.references)
            {
              _iter186.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
      }
      if (struct.containers != null) {
        if (struct.isSetContainers()) {
          oprot.writeFieldBegin(CONTAINERS_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.containers.size()));
            for (ContainerSlot _iter187 : struct.containers)
            {
              _iter187.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class ModelElementTupleSchemeFactory implements org.apache.thrift.scheme.SchemeFactory {
    public ModelElementTupleScheme getScheme() {
      return new ModelElementTupleScheme();
    }
  }

  private static class ModelElementTupleScheme extends org.apache.thrift.scheme.TupleScheme<ModelElement> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, ModelElement struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol oprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet optionals = new java.util.BitSet();
      if (struct.isSetId()) {
        optionals.set(0);
      }
      if (struct.isSetRepositoryURL()) {
        optionals.set(1);
      }
      if (struct.isSetFile()) {
        optionals.set(2);
      }
      if (struct.isSetMetamodelUri()) {
        optionals.set(3);
      }
      if (struct.isSetTypeName()) {
        optionals.set(4);
      }
      if (struct.isSetAttributes()) {
        optionals.set(5);
      }
      if (struct.isSetReferences()) {
        optionals.set(6);
      }
      if (struct.isSetContainers()) {
        optionals.set(7);
      }
      oprot.writeBitSet(optionals, 8);
      if (struct.isSetId()) {
        oprot.writeString(struct.id);
      }
      if (struct.isSetRepositoryURL()) {
        oprot.writeString(struct.repositoryURL);
      }
      if (struct.isSetFile()) {
        oprot.writeString(struct.file);
      }
      if (struct.isSetMetamodelUri()) {
        oprot.writeString(struct.metamodelUri);
      }
      if (struct.isSetTypeName()) {
        oprot.writeString(struct.typeName);
      }
      if (struct.isSetAttributes()) {
        {
          oprot.writeI32(struct.attributes.size());
          for (AttributeSlot _iter188 : struct.attributes)
          {
            _iter188.write(oprot);
          }
        }
      }
      if (struct.isSetReferences()) {
        {
          oprot.writeI32(struct.references.size());
          for (ReferenceSlot _iter189 : struct.references)
          {
            _iter189.write(oprot);
          }
        }
      }
      if (struct.isSetContainers()) {
        {
          oprot.writeI32(struct.containers.size());
          for (ContainerSlot _iter190 : struct.containers)
          {
            _iter190.write(oprot);
          }
        }
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, ModelElement struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TTupleProtocol iprot = (org.apache.thrift.protocol.TTupleProtocol) prot;
      java.util.BitSet incoming = iprot.readBitSet(8);
      if (incoming.get(0)) {
        struct.id = iprot.readString();
        struct.setIdIsSet(true);
      }
      if (incoming.get(1)) {
        struct.repositoryURL = iprot.readString();
        struct.setRepositoryURLIsSet(true);
      }
      if (incoming.get(2)) {
        struct.file = iprot.readString();
        struct.setFileIsSet(true);
      }
      if (incoming.get(3)) {
        struct.metamodelUri = iprot.readString();
        struct.setMetamodelUriIsSet(true);
      }
      if (incoming.get(4)) {
        struct.typeName = iprot.readString();
        struct.setTypeNameIsSet(true);
      }
      if (incoming.get(5)) {
        {
          org.apache.thrift.protocol.TList _list191 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
          struct.attributes = new java.util.ArrayList<AttributeSlot>(_list191.size);
          @org.apache.thrift.annotation.Nullable AttributeSlot _elem192;
          for (int _i193 = 0; _i193 < _list191.size; ++_i193)
          {
            _elem192 = new AttributeSlot();
            _elem192.read(iprot);
            struct.attributes.add(_elem192);
          }
        }
        struct.setAttributesIsSet(true);
      }
      if (incoming.get(6)) {
        {
          org.apache.thrift.protocol.TList _list194 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
          struct.references = new java.util.ArrayList<ReferenceSlot>(_list194.size);
          @org.apache.thrift.annotation.Nullable ReferenceSlot _elem195;
          for (int _i196 = 0; _i196 < _list194.size; ++_i196)
          {
            _elem195 = new ReferenceSlot();
            _elem195.read(iprot);
            struct.references.add(_elem195);
          }
        }
        struct.setReferencesIsSet(true);
      }
      if (incoming.get(7)) {
        {
          org.apache.thrift.protocol.TList _list197 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
          struct.containers = new java.util.ArrayList<ContainerSlot>(_list197.size);
          @org.apache.thrift.annotation.Nullable ContainerSlot _elem198;
          for (int _i199 = 0; _i199 < _list197.size; ++_i199)
          {
            _elem198 = new ContainerSlot();
            _elem198.read(iprot);
            struct.containers.add(_elem198);
          }
        }
        struct.setContainersIsSet(true);
      }
    }
  }

  private static <S extends org.apache.thrift.scheme.IScheme> S scheme(org.apache.thrift.protocol.TProtocol proto) {
    return (org.apache.thrift.scheme.StandardScheme.class.equals(proto.getScheme()) ? STANDARD_SCHEME_FACTORY : TUPLE_SCHEME_FACTORY).getScheme();
  }
}

